Module Dual
    ' General purpose wait where more than 1 sub can use just 1 timer
    ' Timer is set at start up
    Public Sub wait(ByVal tenms)
        Dim timeNow
        With Form1
            timeNow = .t1
            While .t1 <= timeNow + tenms
                Application.DoEvents()
            End While
        End With
    End Sub

    ' Gets a char from the input with time out, reports to info screen if
    ' the specified char is not found
    ' returns 1 if ack found
    ' Time out is 100 ms
    Public Function GetAck(ByVal v As String, ByVal ack As String)
        Dim timeNow, found
        found = 0
        With Form1
            timeNow = .t1
            While .t1 < timeNow + 100
                If InStr(.textIn, ack) > 0 Then
                    found = 1
                    Exit While
                End If
                Application.DoEvents()
            End While
            If found = 0 Then
                .editHelp.Text = .editHelp.Text + vbCrLf + _
                "ERROR did not receive " + ack + " character" + vbCrLf + _
                "Actually received [" + .textIn + "] when sending (" + v
            End If
        End With
        GetAck = found
    End Function

    ' Connect to device and set up for ACK using '>' as the ACK char
    Public Function Connect()
        Dim rv = 0
        With Form1
            ' reset device first, assumes that a BV10x is connected which has
            ' the DTR line connected to the Dual reset line
            .port1.DtrEnable = True
            .port1.DtrEnable = False
            wait(50)

            ' send CR to initialise device
            .textIn = "" ' clear buffer
            .port1.Write(Chr(13))
            wait(50)   ' needs a bit longer for initialisation

            ' get initialisation char
            If GetAck("", "*") = 1 Then   ' set up ACK mechanism
                .port1.Write(Chr(27))
                .port1.Write("[62E") ' 62 is '>' 
                .txtNon.Text = "Connected " + .textIn
                wait(20)
                .editHelp.Text = "Device ID " + Getvalue(Chr(27) + "[?31d")
                rv = 1
            End If
            '
        End With
        Connect = rv
    End Function
 

    ' Extracts the returned value from the device
    Public Function Getvalue(ByVal text)
        With Form1
            .textIn = "" ' clear buffer
            .port1.Write(text) ' send new text
            If GetAck(text, ">") Then ' wait for ack
                ' ack recieved so extract value
                Getvalue = Mid$(.textIn, 1, .textIn.Length - 1)
            Else
                .editHelp.Text = .editHelp.Text + vbCrLf + _
                "ERROR obtaining value, recieved " + .textIn
                Getvalue = 0
            End If
        End With
    End Function
End Module
